package com.hfkj.service.item.impl;

import com.hfkj.dao.EnOilManagementMapper;
import com.hfkj.entity.EnOilManagement;
import com.hfkj.entity.EnOilManagementExample;
import com.hfkj.entity.EnServiceCompanyDevice;
import com.hfkj.service.item.EnOilManagementService;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("enOilManagementService")
public class EnOilManagementServiceImpl implements EnOilManagementService {

    @Resource
    private EnOilManagementMapper enOilManagementMapper;

    @Override
    public void create(EnOilManagement enOilManagement) {
        enOilManagementMapper.insert(enOilManagement);
    }

    @Override
    public void update(EnOilManagement enOilManagement) {
        enOilManagementMapper.updateByPrimaryKey(enOilManagement);
    }

    @Override
    public void delete(Long id, Boolean fullDelete) {
        if (fullDelete) {
            enOilManagementMapper.deleteByPrimaryKey(id);
        } else {
            EnOilManagement enOilManagement = queryDetail(id);
            enOilManagement.setStatus(0);
            enOilManagement.setUpdateTime(new Date());
            update(enOilManagement);
        }
    }

    @Override
    public EnOilManagement queryDetail(Long id) {
        return enOilManagementMapper.selectByPrimaryKey(id);
    }

    @Override
    public EnOilManagement queryDetailByMap(Map<String, Object> map) {
        EnOilManagementExample example = new EnOilManagementExample();
        EnOilManagementExample.Criteria criteria = example.createCriteria();

        if (StringUtils.isNotBlank(MapUtils.getString(map, "transportCarNo"))) {
            criteria.andTransportCarNoNotLike("%"+MapUtils.getString(map, "transportCarNo")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "supplier"))) {
            criteria.andSupplierLike("%"+MapUtils.getString(map, "supplier")+"%");
        }

        if (MapUtils.getInteger(map , "type") != null) {
            criteria.andTypeEqualTo(MapUtils.getInteger(map , "type"));
        }
        if (MapUtils.getInteger(map , "oilType") != null) {
            criteria.andOilTypeEqualTo(MapUtils.getInteger(map , "oilType"));
        }

        if (MapUtils.getLong(map , "transportCarId") != null) {
            criteria.andTransportCarIdEqualTo(MapUtils.getLong(map , "transportCarId"));
        }
        if (MapUtils.getLong(map, "createUser") != null) {
            criteria.andCreateUserEqualTo(MapUtils.getLong(map, "createUser"));
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        }else {
            criteria.andStatusNotEqualTo(0);
        }
        if (MapUtils.getLong(map , "id") != null) {
            criteria.andIdEqualTo(MapUtils.getLong(map , "id"));
        }

        List<EnOilManagement> list = enOilManagementMapper.selectByExample(example);

        return list.isEmpty() ? null : list.get(0);
    }

    @Override
    public List<EnOilManagement> getList(Map<String, Object> map) {
        EnOilManagementExample example = new EnOilManagementExample();
        EnOilManagementExample.Criteria criteria = example.createCriteria();

        if (StringUtils.isNotBlank(MapUtils.getString(map, "transportCarNo"))) {
            criteria.andTransportCarNoNotLike("%"+MapUtils.getString(map, "transportCarNo")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "supplier"))) {
            criteria.andSupplierLike("%"+MapUtils.getString(map, "supplier")+"%");
        }

        if (MapUtils.getInteger(map , "type") != null) {
            criteria.andTypeEqualTo(MapUtils.getInteger(map , "type"));
        }
        if (MapUtils.getInteger(map , "oilType") != null) {
            criteria.andOilTypeEqualTo(MapUtils.getInteger(map , "oilType"));
        }

        if (MapUtils.getLong(map , "transportCarId") != null) {
            criteria.andTransportCarIdEqualTo(MapUtils.getLong(map , "transportCarId"));
        }
        if (MapUtils.getLong(map, "createUser") != null) {
            criteria.andCreateUserEqualTo(MapUtils.getLong(map, "createUser"));
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        }else {
            criteria.andStatusNotEqualTo(0);
        }
        if (MapUtils.getLong(map , "id") != null) {
            criteria.andIdEqualTo(MapUtils.getLong(map , "id"));
        }

        return enOilManagementMapper.selectByExample(example);
    }
}
